require 'dp/parser'
Dir.mkdir('dpi') unless test ?d, 'dpi'
cate = ARGV[0] || 'rtl'
Dir.glob("d:/borland/delphi6/source/#{cate}/**/*.pas") do |fname|
  @p = Parser.new
  @p.load(fname)
  @p.deb.errputs "### #{fname}"
  begin
    ret = @p.parse_interface
    open(File.join('dpi', File.basename(fname, '.pas') << '.dpi'), 'wb') do |soc|
      Marshal.dump(ret, soc)
    end
  rescue
    @p.deb.errputs "!!! #{fname}"
    @p.deb.errputs $!.message,$!.backtrace
  end
end
